/* funz1.f -- translated by f2c (version of 16 May 1991  13:06:06).
   You must link the resulting object file with the libraries:
        -link <S|C|M|L>f2c.lib   (in that order)
*/

#include "f2c.h"
#include "math.h"

extern void   cdiv( doublecomplex *a, doublecomplex *b, doublecomplex *c );
extern double round( double x );

/* C    D1MACH.FOR - Double Precision Machine Constants */
/* C */
doublereal d1mach_(integer *i)
{
    /* Initialized data */

    static struct {
        integer e_1[10];
        doublereal e_2;
        } equiv_4 = { 0, 1048576, -1, 2146435071, 0, 1017118720, 0, 
                1018167296, 1352628735, 1070810131, 0. };


    /* System generated locals */
    doublereal ret_val;

    /* Local variables */
#define log10 ((integer *)&equiv_4 + 8)
#define dmach ((doublereal *)&equiv_4)
#define large ((integer *)&equiv_4 + 2)
#define small ((integer *)&equiv_4)
#define diver ((integer *)&equiv_4 + 6)
#define right ((integer *)&equiv_4 + 4)

    if (*i < 1 || *i > 5) {
        goto L999;
    }
    ret_val = dmach[*i - 1];
L999:
    return ret_val;
} /* d1mach_ */

#undef right
#undef diver
#undef small
#undef large
#undef dmach
#undef log10


/* C    I1MACH.FOR - Integer Machine Constants */
/* C */
integer i1mach_(integer *i)
{
    /* Initialized data */

    static struct {
        integer e_1[16];
        } equiv_0 = { 5, 6, 7, 0, 32, 4, 2, 31, 2147483647, 2, 24, -125, 128, 
                53, -1021, 1024 };


    /* System generated locals */
    integer ret_val;

    /* Local variables */
#define imach ((integer *)&equiv_0)
#define output ((integer *)&equiv_0 + 3)

    if (*i < 1 || *i > 16) {
        goto L10;
    }

    ret_val = imach[*i - 1];
/* /6S */
/* /7S */
    if (*i == 6) {
        ret_val = 1;
    }
/* / */
L10:
    return ret_val;
} /* i1mach_ */

#undef output
#undef imach


/* C    R1MACH.FOR - Real Machine Constants */
/* C */
doublereal r1mach_(integer *i)
{
    /* Initialized data */

    static struct {
        integer e_1[5];
        integer fill_2[1];
        real e_3;
        } equiv_4 = { 8388608, 2139095039, 864026624, 872415232, 1050288283, {
                0}, 0.f };


    /* System generated locals */
    real ret_val;

    /* Local variables */
#define log10 ((integer *)&equiv_4 + 4)
#define large ((integer *)&equiv_4 + 1)
#define rmach ((real *)&equiv_4)
#define small ((integer *)&equiv_4)
#define diver ((integer *)&equiv_4 + 3)
#define right ((integer *)&equiv_4 + 2)

    if (*i < 1 || *i > 5) {
        goto L999;
    }
    ret_val = rmach[*i - 1];
L999:
    return ret_val;
} /* r1mach_ */

#undef right
#undef diver
#undef small
#undef rmach
#undef large
#undef log10

/*--------------------------*/
double d_sign(doublereal *a, doublereal *b)
{
        double fabs( double );

        if (*b >= 0.0) return( fabs( *a ) );
        else return( - fabs( *a ) );
}

double pow_dd(doublereal *a, doublereal *b)
{
        double pow( double , double );

        return( pow( *a , *b ) );
}

double pow_di(doublereal *a, integer *b)
{
        double powi( double , int );

        return( powi( *a , (int)*b ) );
}

double d_int(doublereal *x)
{
        double modf( double , double * );
        double n;

        modf( (double)*x , &n );
        return( n );
}

doublereal cdabs_(doublecomplex *z)
{
        double cabs();

        return( cabs( *z ) );
}

double d_imag(doublecomplex *z)
{
        return( z->i );
}

void z_div(doublecomplex *a, doublecomplex *b, doublecomplex *c)
{
        void cdiv();

        cdiv( c, b, a );
}

double d_lg10(doublereal *x)
{
	return( log10( *x ) );
}

double d_mod(doublereal *x, doublereal *y)
{
	double d, f;

	if ( *y == 0.0 ) return( *x );
	d = (*x) / (*y);
	d = modf( d, &f );
	return( (*y) * d );
}

integer pow_ii(integer *x, integer *y)
{
        double powi( double , int );

        return( (integer)powi( (double)(*x) , (int)*y ) );
}

double r_mod(real *x, real *y)
{
	double d, f;

	if ( *y == 0.0 ) return( *x );
	d = (*x) / (*y);
	d = (*y) * modf( d, &f );
	return( d );
}

integer i_sign(integer *a, integer *b)
{
	integer j;

	if ( *a >= 0 ) j = *a;
	else j = -(*a);
	if ( *b >=0 ) return( j );
	else return( -j );
}

double d_nint(doublereal *x)
{
	return( round( (double)*x ) );
}
